package WebDP::Quiz::Session;

use strict;
use Apache::Session::MySQL;
use CGI::Cookie;

sub open {
    my $class = shift;
    my %cookie = CGI::Cookie->fetch;

    # no cookie, return undef
    return unless exists $cookie{sid};

    my $sid = $cookie{sid}->value;
    my $self = bless {}, $class;
    $self->load($sid);
    return $self;
}

sub create {
    my $class = shift;
    my $self = bless {}, $class;

    # sid=0: new session
    $self->load(0);
    return $self;
}

sub load {
    my($self, $sid) = @_;
    my $session = tie my %session, 'Apache::Session::MySQL', $sid, {
	DataSource => 'dbi:mysql:webdpquiz',
	UserName   => 'www',
	Password   => 'scott',
	LockDataSource => 'dbi:mysql:webdpquiz',
	LockUserName   => 'www',
	LockPassword   => 'scott',
    };
    $self->{session} = $session;
}

sub get {
    my $self = shift;
    $self->{session}->FETCH(@_);
}

sub set {
    my $self = shift;
    $self->{session}->STORE(@_);
}

sub expire {
    my $self = shift;
    $self->{session}->delete;
}

sub clear {
    my $self = shift;
    $self->{session}->DELETE(@_);
}

sub id {
    my $self = shift;
    $self->get('_session_id');
}

sub generate_cookie {
    my $self = shift;
    return CGI::Cookie->new(-name => 'sid', -value => $self->id);
}

1;
