#!/usr/local/bin/perl -Tw

use strict;
use CGI;
use WebDP::Quiz::Session;
use WebDP::Quiz::Questions;

my $query   = CGI->new;
my $session = WebDP::Quiz::Session->open or die "no session";

my $answers = $session->get('answers');

my @judge;
for my $idx (0..$#{$answers}) {
    my $quiz = WebDP::Quiz::Questions->get_quiz($idx) or die "invalid idx";
    push @judge, ($answers->[$idx] == $quiz->{answer});
}

my $total = @judge;
my $correct = scalar grep { $_ == 1 } @judge;
my $avg = int(100 * $correct / $total);

print $query->header(
    -type => 'text/html; charset=euc-jp',
    -cache_control => 'no-cache',
), <<"__HTML__";
<HTML>
<BODY>
Quiz Result:<P>
Total: $total<BR>
Correct: $correct<BR>
Average: $avg%<BR>

<P>
<A href="./entry.cgi">TRY AGAIN</A>
</BODY>
</HTML>
__HTML__

